# Ipopt::Ma27TSolverInterface Class Reference

Interface to the symmetric linear solver MA27, derived from SparseSymLinearSolverInterface. More...

`#include <IpMa27TSolverInterface.hpp>`

Inheritance diagram for Ipopt::Ma27TSolverInterface:
[legend]

List of all members.

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
Constructor/Destructor
| Ma27TSolverInterface ()
| Constructor.
virtual | ~Ma27TSolverInterface ()
| Destructor.
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | InitializeStructure (Index dim, Index nonzeros, const Index *airn, const Index *ajcn)
| Method for initializing internal stuctures.
virtual double * | GetValuesArrayPtr ()
| Method returing an internal array into which the nonzero elements (in the same order as airn and ajcn) are to be stored by the calling routine before a call to MultiSolve with a new_matrix=true.
virtual ESymSolverStatus | MultiSolve (bool new_matrix, const Index *airn, const Index *ajcn, Index nrhs, double *rhs_vals, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for multiple right hand sides.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last factorization.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| Ma27TSolverInterface (const Ma27TSolverInterface &)
| Copy Constructor.
void | operator= (const Ma27TSolverInterface &)
| Overloaded Equals Operator.
Internal functions
ESymSolverStatus | SymbolicFactorization (const Index *airn, const Index *ajcn)
| Call MA27AD and reserve memory for MA27 data.
ESymSolverStatus | Factorization (const Index *airn, const Index *ajcn, bool check_NegEVals, Index numberOfNegEVals)
| Call MA27BD to factorize the Matrix.
ESymSolverStatus | Backsolve (Index nrhs, double *rhs_vals)
| Call MA27CD to do the backsolve.
## Private Attributes
Information about the matrix
Index | dim_
| Number of rows and columns of the matrix.
Index | nonzeros_
| Number of nonzeros of the matrix.
Information about most recent factorization/solve
Index | negevals_
| Number of negative eigenvalues.
Initialization flags
bool | initialized_
| Flag indicating if internal data is initialized.
bool | pivtol_changed_
| Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed.
bool | refactorize_
| Flag that is true if we just requested the values of the matrix again (SYMSOLVER_CALL_AGAIN) and have to factorize again.
Solver specific data/options
Number | pivtol_
| Pivol tolerance.
Number | pivtolmax_
| Maximal pivot tolerance.
Number | liw_init_factor_
| Factor for estimating initial value of liw.
Number | la_init_factor_
| Factor for estimating initial value of la.
Number | meminc_factor_
| Factor for increaseing memory.
bool | warm_start_same_structure_
| Flag indicating whether the TNLP with identical structure has already been solved before.
bool | skip_inertia_check_
| Flag indicating if the interia is always assumed to be correct.
bool | ignore_singularity_
| Flag indicating if MA27 should continue if a singular matrix is detected, but right hands sides are still accepted.
Data for the linear solver.
Storing factorization and other solver specific data structure.
ipfint | icntl_ [30]
| integer control values
double | cntl_ [5]
| real control values
ipfint | liw_
| length of integer work space
ipfint * | iw_
| integer work space
ipfint * | ikeep_
| MA27's IKEEP.
ipfint | nsteps_
| MA27's NSTEPS.
ipfint | maxfrt_
| MA27's MAXFRT.
ipfint | la_
| length LA of A
double * | a_
| factor A of matrix
bool | la_increase_
| flag indicating that la should be increased before next factorization
bool | liw_increase_
| flag indicating that liw should be increased before next factorization
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
EMatrixFormat | MatrixFormat () const
| Query of requested matrix type that the linear solver understands.
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for IpoptType.

## Detailed Description

Interface to the symmetric linear solver MA27, derived from SparseSymLinearSolverInterface.

Definition at line 19 of file IpMa27TSolverInterface.hpp.

## Constructor & Destructor Documentation

Ipopt::Ma27TSolverInterface::Ma27TSolverInterface | ( |  | ) |

Constructor.

virtual Ipopt::Ma27TSolverInterface::~Ma27TSolverInterface | ( |  | ) | `[virtual]`

Destructor.

Ipopt::Ma27TSolverInterface::Ma27TSolverInterface | ( | const Ma27TSolverInterface & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::Ma27TSolverInterface::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::Ma27TSolverInterface::InitializeStructure | ( | Index | dim,
|  | Index | nonzeros,
|  | const Index * | airn,
|  | const Index * | ajcn |
| ) |  |  | `[virtual]`

Method for initializing internal stuctures.

Here, ndim gives the number of rows and columns of the matrix, nonzeros give the number of nonzero elements, and airn and acjn give the positions of the nonzero elements.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual double* Ipopt::Ma27TSolverInterface::GetValuesArrayPtr | ( |  | ) | `[virtual]`

Method returing an internal array into which the nonzero elements (in the same order as airn and ajcn) are to be stored by the calling routine before a call to MultiSolve with a new_matrix=true.

The returned array must have space for at least nonzero elements.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::Ma27TSolverInterface::MultiSolve | ( | bool | new_matrix,
|  | const Index * | airn,
|  | const Index * | ajcn,
|  | Index | nrhs,
|  | double * | rhs_vals,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Solve operation for multiple right hand sides.

Overloaded from SparseSymLinearSolverInterface.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual Index Ipopt::Ma27TSolverInterface::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last factorization.

Returns the number of negative eigenvalues of the most recent factorized matrix. This must not be called if the linear solver does not compute this quantities (see ProvidesInertia).

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::Ma27TSolverInterface::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Ask linear solver to increase quality of solution for the next solve (e.g. increase pivot tolerance). Returns false, if this is not possible (e.g. maximal pivot tolerance already used.)

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::Ma27TSolverInterface::ProvidesInertia | ( |  | ) | const`[inline, virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 86 of file IpMa27TSolverInterface.hpp.

EMatrixFormat Ipopt::Ma27TSolverInterface::MatrixFormat | ( |  | ) | const`[inline, virtual]`

Query of requested matrix type that the linear solver understands.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 93 of file IpMa27TSolverInterface.hpp.

static void Ipopt::Ma27TSolverInterface::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for IpoptType.

void Ipopt::Ma27TSolverInterface::operator= | ( | const Ma27TSolverInterface & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::AlgorithmStrategyObject.

ESymSolverStatus Ipopt::Ma27TSolverInterface::SymbolicFactorization | ( | const Index * | airn,
|  | const Index * | ajcn |
| ) |  |  | `[private]`

Call MA27AD and reserve memory for MA27 data.

Reserve memory for iw_ and ikeep_, call MA27AD to perform symbolic manipulations, and reserve all the remaining data memory

ESymSolverStatus Ipopt::Ma27TSolverInterface::Factorization | ( | const Index * | airn,
|  | const Index * | ajcn,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call MA27BD to factorize the Matrix.

It is assumed that the first nonzeros_ element of a_ contain the values of the matrix to be factorized.

ESymSolverStatus Ipopt::Ma27TSolverInterface::Backsolve | ( | Index | nrhs,
|  | double * | rhs_vals |
| ) |  |  | `[private]`

Call MA27CD to do the backsolve.

## Member Data Documentation

Index Ipopt::Ma27TSolverInterface::dim_`[private]`

Number of rows and columns of the matrix.

Definition at line 123 of file IpMa27TSolverInterface.hpp.

Index Ipopt::Ma27TSolverInterface::nonzeros_`[private]`

Number of nonzeros of the matrix.

Definition at line 126 of file IpMa27TSolverInterface.hpp.

Index Ipopt::Ma27TSolverInterface::negevals_`[private]`

Number of negative eigenvalues.

Definition at line 132 of file IpMa27TSolverInterface.hpp.

bool Ipopt::Ma27TSolverInterface::initialized_`[private]`

Flag indicating if internal data is initialized.

For initialization, this object needs to have seen a matrix

Definition at line 139 of file IpMa27TSolverInterface.hpp.

bool Ipopt::Ma27TSolverInterface::pivtol_changed_`[private]`

Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed.

Definition at line 142 of file IpMa27TSolverInterface.hpp.

bool Ipopt::Ma27TSolverInterface::refactorize_`[private]`

Flag that is true if we just requested the values of the matrix again (SYMSOLVER_CALL_AGAIN) and have to factorize again.

Definition at line 146 of file IpMa27TSolverInterface.hpp.

Number Ipopt::Ma27TSolverInterface::pivtol_`[private]`

Pivol tolerance.

Definition at line 152 of file IpMa27TSolverInterface.hpp.

Number Ipopt::Ma27TSolverInterface::pivtolmax_`[private]`

Maximal pivot tolerance.

Definition at line 155 of file IpMa27TSolverInterface.hpp.

Number Ipopt::Ma27TSolverInterface::liw_init_factor_`[private]`

Factor for estimating initial value of liw.

Definition at line 158 of file IpMa27TSolverInterface.hpp.

Number Ipopt::Ma27TSolverInterface::la_init_factor_`[private]`

Factor for estimating initial value of la.

Definition at line 160 of file IpMa27TSolverInterface.hpp.

Number Ipopt::Ma27TSolverInterface::meminc_factor_`[private]`

Factor for increaseing memory.

Definition at line 162 of file IpMa27TSolverInterface.hpp.

bool Ipopt::Ma27TSolverInterface::warm_start_same_structure_`[private]`

Flag indicating whether the TNLP with identical structure has already been solved before.

Definition at line 165 of file IpMa27TSolverInterface.hpp.

bool Ipopt::Ma27TSolverInterface::skip_inertia_check_`[private]`

Flag indicating if the interia is always assumed to be correct.

Definition at line 168 of file IpMa27TSolverInterface.hpp.

bool Ipopt::Ma27TSolverInterface::ignore_singularity_`[private]`

Flag indicating if MA27 should continue if a singular matrix is detected, but right hands sides are still accepted.

Definition at line 171 of file IpMa27TSolverInterface.hpp.

ipfint Ipopt::Ma27TSolverInterface::icntl_[30]`[private]`

integer control values

Definition at line 179 of file IpMa27TSolverInterface.hpp.

double Ipopt::Ma27TSolverInterface::cntl_[5]`[private]`

real control values

Definition at line 181 of file IpMa27TSolverInterface.hpp.

ipfint Ipopt::Ma27TSolverInterface::liw_`[private]`

length of integer work space

Definition at line 184 of file IpMa27TSolverInterface.hpp.

ipfint* Ipopt::Ma27TSolverInterface::iw_`[private]`

integer work space

Definition at line 186 of file IpMa27TSolverInterface.hpp.

ipfint* Ipopt::Ma27TSolverInterface::ikeep_`[private]`

MA27's IKEEP.

Definition at line 189 of file IpMa27TSolverInterface.hpp.

ipfint Ipopt::Ma27TSolverInterface::nsteps_`[private]`

MA27's NSTEPS.

Definition at line 191 of file IpMa27TSolverInterface.hpp.

ipfint Ipopt::Ma27TSolverInterface::maxfrt_`[private]`

MA27's MAXFRT.

Definition at line 193 of file IpMa27TSolverInterface.hpp.

ipfint Ipopt::Ma27TSolverInterface::la_`[private]`

length LA of A

Definition at line 196 of file IpMa27TSolverInterface.hpp.

double* Ipopt::Ma27TSolverInterface::a_`[private]`

factor A of matrix

Definition at line 198 of file IpMa27TSolverInterface.hpp.

bool Ipopt::Ma27TSolverInterface::la_increase_`[private]`

flag indicating that la should be increased before next factorization

Definition at line 202 of file IpMa27TSolverInterface.hpp.

bool Ipopt::Ma27TSolverInterface::liw_increase_`[private]`

flag indicating that liw should be increased before next factorization

Definition at line 205 of file IpMa27TSolverInterface.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/LinearSolvers/IpMa27TSolverInterface.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines